autopkgtest-virt-lxd(1)

NAME
autopkgtest-virt-lxd, autopkgtest-virt-incus - autopkgtest virtualisation server using LXD/Incus

SYNOPSIS
autopkgtest [...] -- lxd [options] image [-- extra lxc launch args...]

autopkgtest [...] -- incus [options] image [-- extra incus launch args...]

DESCRIPTION
autopkgtest-virt-lxd provides an autopkgtest virtualisation server using LXD or Incus. It creates temporary containers or VMs (depending the image type) from the given LXD/Incus image name.

Normally autopkgtest-virt-lxd will be invoked by autopkgtest.

REQUIREMENTS
When run as autopkgtest-virt-lxd or with the --lxd option, LXD is used. When run as autopkgtest-virt-incus or with the --incus option, Incus is used.

autopkgtest-virt-lxd makes no strict assumptions about the image. However, it is highly recommended that the image has eatmydata installed, or at least that gets installed via setup commands.

For production use, it is recommended to use autopkgtest-build-lxd(1) or autopkgtest-build-incus(1) to generate an optimized image with autopkgtest's standard setup commands applied. Then these setup commands don't need to be applied for every test. This is particularly necessary if you want to use --apt-source tests, i. e. use apt-get source in the test bed to download the package to test. Standard images from linuxcontainers.org do not have "deb-src" apt sources by default.

OPTIONS

--lxd
    Use LXD. This is the default when invoked as autopkgtest-virt-lxd.

--incus
    Use Incus. This is the default when invoked as autopkgtest-virt-incus.

-r remote | --remote=remote
    Run instance on given remote host instead of the current default. See lxc remote list or incus remote list for available remotes.

    This option also sets the remote used for the image, unless the image argument includes a remote (e.g. images:debian/sid).

-p project | --project=project
    Run instance in a given project instead of the current one. See lxc project list or incus project list for available projects.

--name NAME
    Set a custom name for the temporary instance in which to run the test. This is autogenerated by default, but if you have a way to generate more expressive unique names you can use that to make it easier to map instances to running tests.

-d | --debug
    Enables debugging output.

--delete-existing
    If an instance is already running with the same name as this one, replace it. Meant to be used in conjunction with the --name option.

You can pass additional options to lxc launch or incus launch: Anything after a -- gets appended verbatim to lxc launch image or incus launch image.

INPUT, OUTPUT AND EXIT STATUS
The behaviour of autopkgtest-virt-lxd is as described by the AutomatedTesting virtualisation regime specification.

EXAMPLE

(If using Incus rather than LXD, substitute incus for each of lxc and lxd in the following examples.)

Show available images on the standard linuxcontainers.org remote image server:

        lxc image list images:

Run the tests of a local built directory tree on the current Debian sid image from the above images: remote:

        autopkgtest my-package/ -- lxd images:debian/sid/amd64

Run the tests in a local built directory tree from a local LXD image desktop/i386, ensuring that eatmydata is installed:

        autopkgtest --setup-commands 'apt-get install -y eatmydata' dir/to/test/ \
          -- lxd desktop/i386

Run the tests of the gdk-pixbuf package on the current Debian sid image from the images: remote on a remote armhf host:

        lxc remote add armhf-test http://armhf.testlab.example.com:8443
        autopkgtest --setup-commands=setup-testbed gdk-pixbuf -- \
           lxd --remote armhf-test images:debian/sid/armhf

Build a local image with standard setup commands pre-applied from a remote standard image, and run gdk-pixbuf test in it:

        autopkgtest-build-lxd images:ubuntu/xenial/amd64
        autopkgtest gdk-pixbuf -- lxd autopkgtest/ubuntu/xenial/amd64

SEE ALSO
autopkgtest(1), autopkgtest-build-lxd(1), /usr/share/doc/autopkgtest/.

AUTHORS AND COPYRIGHT
autopkgtest-virt-lxd was written by Martin Pitt <martin.pitt@ubuntu.com>.

This manpage is part of autopkgtest, a tool for testing Debian binary packages. autopkgtest is Copyright (C) 2006-2015 Canonical Ltd and others.

See /usr/share/doc/autopkgtest/CREDITS for the list of contributors and full copying conditions.